
using Godot;


namespace Rokojori
{  
  [GlobalClass ]
  public partial class SetTimeLineSpeed : Action
  {
    [Export]
    public TimeLine timeline;

    [Export]
    public float speed = 1;

    protected override void _OnTrigger()
    {
      var tm = Unique<TimeLineManager>.Get();      
      tm.SetSpeed( timeline, speed );
    }

  }
}