
using Godot;


namespace Rokojori
{  
  [Tool]
  [GlobalClass]
  public partial class TriggerActionInEditor : Node
  {
    [Export]
    public Action action;

    [Export]
    public bool execute;

    public override void _Process( double delta )
    {
      if ( ! execute )
      {
        return;
      }

      execute = false;

      action.Trigger();
    } 
  }
}